!  1.5 tsvZ@\LU\
program matrix_inversion
   implicit none
   real a(5,5),ai(5,5),b(5),det
   integer ipv(5)
   integer i,j,k,n
   a(1,1) = 2;  a(1,2) = 4;  a(1,3) =  5;  a(1,4) =  2;  a(1,5) = -3
   a(2,1) = 1;  a(2,2) = 3;  a(2,3) =  2;  a(2,4) = -6;  a(2,5) = -1
   a(3,1) = 4;  a(3,2) = 1;  a(3,3) = -3;  a(3,4) = -2;  a(3,5) = -2
   a(4,1) = 1;  a(4,2) = 7;  a(4,3) =  1;  a(4,4) =  3;  a(4,5) = -6
   a(5,1) = 3;  a(5,2) = 4;  a(5,3) = -1;  a(5,4) = -3;  a(5,5) =  3
   n = 5
   call ludecomposition(a,n,ipv,det)
   do k = 1, n
      b = 0
      b(k) = 1
      call lusolution(a,ipv,b,n,ai(1,k))
   enddo
   do i = 1, n
      print "(10f13.7)",(ai(i,j),j=1,n)
   enddo
end program matrix_inversion

subroutine ludecomposition(a,n,ipv,det)
   implicit none
   real a(n,n),det,dd,amax
   integer n,ipv(n),i,j,k,imax,ip
   do i = 1, n
      ipv(i) = i
   enddo
   ip = 1
   do k = 1, n-1
      amax = a(ipv(k),k)
      imax = k
      do i = k+1, n
         if (amax < abs(a(ipv(i),k))) then
            amax = abs(a(ipv(i),k))
            imax = i
         endif
      enddo
      if (imax /= k) then
         j = ipv(k)
         ipv(k) = ipv(imax)
         ipv(imax) = j
         ip = -ip
      endif
      do i = k+1, n
         dd = a(ipv(i),k)/a(ipv(k),k)
         do j = k+1, n
            a(ipv(i),j) = a(ipv(i),j) - dd*a(ipv(k),j)
         enddo
         a(ipv(i),k) = dd
      enddo
   enddo
   det = a(ipv(1),1)
   do i = 2, n
      det = det*a(ipv(i),i)
   enddo
   det = det*ip
end subroutine ludecomposition

subroutine lusolution(a,ipv,b,n,x)
   implicit none
   real a(n,n),b(n),x(n),dd
   integer n,ipv(n),i,j
   do j = 1, n-1
      do i = j+1, n
         b(ipv(i)) = b(ipv(i)) - a(ipv(i),j)*b(ipv(j))
      enddo
   enddo
   x(n) = b(ipv(n))/a(ipv(n),n)
   do i = n-1, 1, -1
      dd = b(ipv(i))
      do j = i+1, n
         dd = dd - a(ipv(i),j)*x(j)
      enddo
      x(i) = dd/a(ipv(i),i)
   enddo
end subroutine lusolution
