!  1.6 Ώ̑эs̘A1̉@@\CRXL[\
program matrix_cholesky
   implicit none
   integer, parameter :: nm = 9, nb = 3
   real a(nm,nb+1),b(nm),x(nm)
   integer i,j
   do i = 1, nm
      a(i,1) = 5
      a(i,2) = -2
      a(i,3) = -1
      a(i,4) = 1
      b(i)   = i-5
   enddo
   call bandcholesky(a,b,nm,nb,x,1)
   do i = 1, nm
      print "(4f10.5)",(a(i,j),j=1,nb+1)
   enddo
   do i = 1, nm
      print *,'X(i) = ',i,x(i)
   enddo
end program matrix_cholesky

subroutine bandcholesky(a,b,n,m,x,mode)
   implicit none
   real a(n,m+1),b(n),x(n)
   integer n,m,mode,i,j,k
   if (mode == 1) then
      do j = 1, n
         do i = j, min(j+m,n)
            do k = max(1,i-m), j-1
               a(j,i-j+1) = a(j,i-j+1) - a(k,1)*a(k,i-k+1)*a(k,j-k+1)
            enddo
         enddo
         do i = j+1, min(j+m,n)
            a(j,i-j+1) = a(j,i-j+1)/a(j,1)
         enddo
      enddo
   endif
   x = b
   do i = 2, n
      do j = max(1,i-m), i-1
         x(i) = x(i) - a(j,i-j+1)*x(j)
      enddo
   enddo
   do i = n, 1, -1
      x(i) = x(i)/a(i,1)
      do j = i+1, min(i+m,n)
         x(i) = x(i) - a(i,j-i+1)*x(j)
      enddo
   enddo
end subroutine bandcholesky
