!  1.7 3dΊpA1̉@@\KEX̏@\
program tridiagonal_matrix_test
   implicit none
   integer, parameter :: nm = 30
   real a(nm),b(nm),c(nm),d(nm),x(nm)
   integer i
   do i = 1, nm
      a(i) = i-0.5
      b(i) =  -2*i
      c(i) = i+0.5
   enddo
   do i = 1, nm
      d(i) = -2*sin(0.1*i**2-5)
   enddo
   call tridiagonal_matrix(a,b,c,d,nm,x)
   do i = 1, nm
      print *,i,x(i)
   enddo
end program tridiagonal_matrix_test

subroutine tridiagonal_matrix(a,b,c,d,n,x)
   implicit none
   real a(n),b(n),c(n),d(n),x(n)
   real G(n),H(n),den
   integer i,n
   G(1) = -c(1)/b(1)
   H(1) = d(1)/b(1)
   do i = 2, n
      den  = 1/(b(i) + a(i)*G(i-1))
      G(i) = -c(i)*den
      H(i) = (d(i) - a(i)*H(i-1))*den
   enddo
   x(n) = H(n)
   do i = n-1, 1, -1
      x(i) = G(i)*x(i+1) + H(i)
   enddo
end subroutine tridiagonal_matrix
