!  1.8 ubN3dΊpA1̉@@\ubNk@\
program matrix_2dcyclic
   implicit none
   integer, parameter :: nx = 7, ny = 7
   real a(nx),b(nx),c(nx),d(nx,ny),x(nx,ny)
   integer i,j
   do i = 1, nx
      a(i) = -1
      b(i) =  4
      c(i) = -1
   enddo
   do j = 1, ny
      do i = 1, nx
         d(i,j) = 2*sin(0.1*i**2+0.3*j-5)
      enddo
   enddo
   call cyclic_reduction_2d(a,b,c,d,nx,ny,x)
   do j = 1, ny
      do i = 1, nx
         print *,i,j,x(i,j)
      enddo
   enddo
end program matrix_2dcyclic

subroutine cyclic_reduction_2d(a,b,c,d,m,n,x)
   implicit none
   real a(m),b(m),c(m),d(m,n),x(m,n)
   real,allocatable :: yr(:),pr(:,:),roots(:),br(:)
   real, parameter :: pi = 3.141592653589793
   integer m,n,n0,i,j,k,nd,i2,l,l0,ls(n)
   k  = 0
   n0 = n + 1
   do i = 1, n
      if (mod(n0,2) /= 0) then
         print *,'Matrix shape must be m * (2**k-1) :',m,'*',n
         return
      endif
      n0 = n0/2
      k  = k + 1
      if (n0 <= 1) exit
   enddo
   allocate ( yr(m), pr(m,n), roots(n), br(m) )
   n0 = n + 1
   x(:,:)  = d(:,:)
   pr(:,:) = 0
   nd = 1
   ls(1) = 0
   roots(1) = 0
   do j = 1, k-1
      i2 = nd;      nd = nd*2;      l0 = ls(j)
      do l = 1, i2/2
         roots(l0+2*l)   = 2*sin((2*l-1-i2)*pi/(2*i2))
         roots(l0+2*l-1) = -roots(l0+2*l)
      enddo
      do i = nd, n0-nd, nd
         yr(:) = x(:,i) + pr(:,i-i2) + pr(:,i+i2)
         do l = l0+1, l0+i2
            br(:) = b(:) - roots(l)
            call tridiagonal_matrix(a,br,c,yr,m,yr)
         enddo
         pr(:,i) = pr(:,i) + yr(:)
         x(:,i) = x(:,i-i2) + x(:,i+i2) + 2*pr(:,i)
      enddo
      ls(j+1) = ls(j) + i2
   enddo
   nd = n0;   i2 = nd/2;   l0 = ls(k)
   do l = 1, i2/2
      roots(l0+2*l)   = 2*sin((2*l-1-i2)*pi/(2*i2))
      roots(l0+2*l-1) = -roots(l0+2*l)
   enddo
   yr(:) = x(:,i2)
   do l = l0+1, l0+i2
      br(:) = b(:) - roots(l)
      call tridiagonal_matrix(a,br,c,yr,m,yr)
   enddo
   x(:,i2) = pr(:,i2) + yr(:)
   do j = k-1, 1, -1
      nd = i2;      i2 = i2/2
      yr(:) = x(:,i2) + x(:,i2*2)
      l0 = ls(j)
     do l = l0+1, l0+i2
         br(:) = b(:) - roots(l)
         call tridiagonal_matrix(a,br,c,yr,m,yr)
      enddo
      x(:,i2) = pr(:,i2) + yr(:)
      do i = i2+nd, n0-nd-i2, nd
         yr(:) = x(:,i) + x(:,i-i2) + x(:,i+i2)
         do l = l0+1, l0+i2
            br(:) = b(:) - roots(l)
            call tridiagonal_matrix(a,br,c,yr,m,yr)
         enddo
         x(:,i) = pr(:,i) + yr(:)
      enddo
      yr(:) = x(:,n0-i2) + x(:,n0-i2*2)
      do l = l0+1, l0+i2
         br(:) = b(:) - roots(l)
         call tridiagonal_matrix(a,br,c,yr,m,yr)
      enddo
      x(:,n0-i2) = pr(:,n0-i2) + yr(:)
   enddo
   deallocate ( yr, pr, roots, br )
end subroutine cyclic_reduction_2d

subroutine tridiagonal_matrix(a,b,c,d,n,x)
   implicit none
   real a(n),b(n),c(n),d(n),x(n)
   real G(n),H(n),den
   integer i,n
   G(1) = -c(1)/b(1)
   H(1) = d(1)/b(1)
   do i = 2, n
      den  = 1/(b(i) + a(i)*G(i-1))
      G(i) = -c(i)*den
      H(i) = (d(i) - a(i)*H(i-1))*den
   enddo
   x(n) = H(n)
   do i = n-1, 1, -1
      x(i) = G(i)*x(i+1) + H(i)
   enddo
end subroutine tridiagonal_matrix
