!  2.5 `̔@3@\@2@̕p\
program x_cosx_secant
   implicit none
   real x1,x2,x,eps,xcosx
   external xcosx
   integer ind
   x1 = -2
   x2 = 2
   eps = 1e-10
   call secant(xcosx,x1,x2,x,eps,ind)
   if (ind >= 0) then
      print *,'X = ',x,xcosx(x),ind
    else if (ind == -1) then
      print *,'f(x1)*f(x2) must be less than 0'
    else
      print *,'No Convergence !'
   endif
end program x_cosx_secant

function xcosx(x)
   real xcosx,x
   xcosx = x**3 - cos(x**2)
end function xcosx

subroutine secant(func,x10,x20,x,eps,ind)
   implicit none
   real func,x10,x20,x,eps,x1,x2,y1,y2,xm,ym,xs,ys
   external func
   integer ind,it,ib
   integer, parameter :: itmax=100
   x1 = x10
   x2 = x20
   y1 = func(x1)
   y2 = func(x2)
   ind = 0
   if (y1 == 0) then
      x = x1
      return
    else if (y2 == 0) then
      x = x2
      return
    else if (y1*y2 > 0) then
      ind = -1
      return
   endif
   if (abs(y1) < abs(y2)) then
      xm = x1;  x1 = x2;  x2 = xm
      ym = y1;  y1 = y2;  y2 = ym
   endif
   xs = x1;  ys = y1
   do it = 1, itmax
      xm = x2 - (x2-x1)/(y2-y1)*y2
      ib = 0
      if (xm < min(x2,xs) .or. xm > max(x2,xs)) then
         xm = (xs+x2)/2
         ib = 1
      endif
      ym = func(xm)
      if (ym == 0) then
         x = xm
         exit
      endif
      if (y2*ym < 0) then
         xs = x2;  ys = y2
         x1 = x2;  y1 = y2
       else if (ib > 0) then
         x1 = xs;  y1 = ys
       else
         x1 = x2;  y1 = y2
      endif
      x2 = xm;  y2 = ym
      if (abs(x2-x1) < eps) then
         x = xm
         exit
      endif
   enddo
   if (it > itmax) then
      ind = -itmax
    else
      ind = it
   endif
end subroutine secant
