!  2.6 `̔@4@\j[g@\
program sincosx_newton
   implicit none
   real x1,x2,x,eps,y,dy,xmin,xmax,dx
   external sincosx
   integer ind,n,nmax
   xmin = 0
   xmax = 6
   nmax = 10
   dx   = (xmax-xmin)/nmax
   x1   = xmin
   eps  = 1e-10
   do n = 1, nmax
      x2 = xmin + dx*n
      call newton(sincosx,x1,x2,x,eps,ind)
      if (ind >= 0) then
         call sincosx(x,y,dy)
         print *,'X = ',x,y,ind
       else if (ind < -1) then
         print *,'No Convergence !'
      endif
      x1 = x2
   enddo
end program sincosx_newton

subroutine sincosx(x,f,df)
   real x,f,df
   f  = cos(x)/2 - sin(x*x/2)
   df = -sin(x)/2 - x*cos(x*x/2)
end subroutine sincosx

subroutine newton(subr,x10,x20,x,eps,ind)
   implicit none
   real x10,x20,x,eps,x1,x2,y2,dy2,xm,ym,dym,xs
   external subr
   integer ind,it,ib
   integer, parameter :: itmax=100
   xm = x10
   x2 = x20
   call subr(xm,ym,dym)
   call subr(x2,y2,dy2)
   ind = 0
   if (ym == 0) then
      x = xm
      return
    else if (y2 == 0) then
      x = x2
      return
    else if (ym*y2 > 0) then
      ind = -1
      return
   endif
   if (abs(ym) < abs(y2)) then
      xs = xm;  xm = x2;  x2 = xs
      y2 = ym;  dy2 = dym
   endif
   xs = xm;  x1 = xm
   do it = 1, itmax
      xm = x2 - y2/dy2
      ib = 0
      if (xm < min(x2,xs) .or. xm > max(x2,xs)) then
         xm = (xs+x2)/2
         ib = 1
      endif
      call subr(xm,ym,dym)
      if (ym == 0) then
         x = xm
         exit
      endif
      if (y2*ym < 0) then
         xs = x2;  x1 = x2
       else if (ib > 0) then
         x1 = xs
       else
         x1 = x2
      endif
      x2 = xm;  y2 = ym;  dy2 = dym
      if (abs(x2-x1) < eps) then
         x = xm
         exit
      endif
   enddo
   if (it > itmax) then
      ind = -itmax
    else
      ind = it
   endif
end subroutine newton
