!  2.7 f`̔@@\j[g@\
program cexpz3_newton
   implicit none
   real xmin,xmax,ymin,ymax,eps
   complex z(10)
   integer n,nmax,nroot
   external cexpz3
   xmin = -10
   xmax = 10
   ymin = -10
   ymax = 10
   nmax = 20
   nroot = 10
   eps  = 1e-10
   call croots_newton(cexpz3,xmin,xmax,nmax,ymin,ymax,nmax,z,nroot,eps)
   do n = 1, nroot
      print *,n,z(n)
   enddo
end program cexpz3_newton

subroutine cexpz3(z,cf,cdf)
   complex z,cf,cdf
   cf  = exp(z) - z*z*z
   cdf = exp(z) - 3*z*z
end subroutine cexpz3

subroutine croots_newton(csubr,xmin,xmax,nx,ymin,ymax,ny,zroot,nroot,eps)
   implicit none
   real xmin,xmax,ymin,ymax,eps,dx,dy,x,y
   integer nx,ny,nr,nroot,l,m,k,iadj
   integer ic(4),md(4),im,insm(4),ind
   integer, allocatable :: isuv(:,:)
   complex zroot(*),w,dw
   external csubr
   dx   = (xmax-xmin)/nx
   dy   = (ymax-ymin)/ny
   allocate ( isuv(0:nx,0:ny) )
   do m = 0, ny
      y = dy*m + ymin
      do l = 0, nx
         x = dx*l + xmin
         call csubr(cmplx(x,y),w,dw)
         if (real(w) >= 0) then
            if (imag(w) >= 0) then
               isuv(l,m) = 1
             else
               isuv(l,m) = 2
            endif
          else
            if (imag(w) >= 0) then
               isuv(l,m) = 3
             else
               isuv(l,m) = 4
            endif
         endif
      enddo
   enddo
   nr = 0
   if (nroot <= 0) nroot = nx*ny
out : do m = 0, ny-1
      do l = 0, nx-1
         ic(1) = isuv(l,m)
         ic(2) = isuv(l+1,m)
         ic(3) = isuv(l,m+1)
         ic(4) = isuv(l+1,m+1)
         im = 0
         do k = 1, 4
            if (ic(k) > 2) then
               im = im + 1
               insm(im) = k
            endif
            md(k) = mod(ic(k),2)
         enddo
         if (im == 1) then
            if (((insm(1) == 1 .or. insm(1) == 4) .and. &
                                   md(2) /= md(3)) .or. &
                ((insm(1) == 2 .or. insm(1) == 3) .and. &
                                   md(1) /= md(4))) im = -1
          else if (im == 2) then
            iadj = insm(1)+insm(2)
            if ((iadj == 3 .and. md(3) /= md(4)) .or. &
                (iadj == 4 .and. md(2) /= md(4)) .or. &
                (iadj == 6 .and. md(1) /= md(3)) .or. &
                (iadj == 7 .and. md(1) /= md(2))) im = -1
         endif
        if (im < 0) then
            w = cmplx(dx*(l+0.5)+xmin, dy*(m+0.5)+ymin)
            call complex_newton(csubr,w,eps,ind)
            if (ind >= 0) then
               if (nr >= nroot) exit out
               nr = nr + 1
               zroot(nr) = w
            endif
         endif
      enddo
   enddo out
   nroot = nr
   deallocate ( isuv )
end subroutine croots_newton

subroutine complex_newton(csubr,z0,eps,ind)
   implicit none
   complex z0,z,z1,cf,cdf
   real eps
   integer ind,it
   integer, parameter :: itmax=100
   external csubr
   z = z0;   z1 = z
   do it = 1, itmax
      call csubr(z,cf,cdf)
      if (cf == 0) exit
      z1 = z - cf/cdf
      if (abs(z1-z) < eps) exit
      z = z1
   enddo
   if (it > itmax) then
      ind = -itmax
    else
      ind = it
   endif
   z0 = z1
end subroutine complex_newton
