!  3.1 2̐šŗLlƌŗLxNg
program eigenvalue_2
   implicit none
   real a(2,2),x(2,2),eigen(2)
   real u,v,d
   real, parameter :: eps = 1e-14
   integer k
   a(1,1) = 5;    a(1,2) = -6
   a(2,1) = -6;   a(2,2) = 8
   u = a(1,1) + a(2,2)
   v = a(1,1)*a(2,2) - a(1,2)*a(2,1)
   d = sqrt(u*u-4*v)
   eigen(1) = (u + d)/2
   eigen(2) = (u - d)/2
   do k = 1, 2
      if (abs(a(1,1)-eigen(k)) > eps .or. abs(a(1,2)) > eps) then
         x(1,k) = -a(1,2)
         x(2,k) = a(1,1) - eigen(k)
       else
         x(1,k) = a(2,2) - eigen(k)
         x(2,k) = -a(2,1)
      endif
      d = sqrt(x(1,k)*x(1,k) + x(2,k)*x(2,k))
      x(1,k) = x(1,k)/d;    x(2,k) = x(2,k)/d
   enddo
   call check_eigenvalue(a,eigen(1),x(1,1),2)
   call check_eigenvalue(a,eigen(2),x(1,2),2)
end program eigenvalue_2

subroutine check_eigenvalue(a,eigen,x,n)
   implicit none
   real a(n,n),eigen,x(n),xe,err
   integer n,i,j
   character(80) form
   err = 0
   do i = 1, n
      xe = 0
      do j = 1, n
         xe = xe + a(i,j)*x(j)
      enddo
      err = max(err,abs(eigen*x(i)-xe))
   enddo
   print "('  Eigenvalue  = ',f14.7,'   Error = ',es11.4)",eigen,err
   form = "('  Eigenvector = (',f12.5,@(',',f12.5),')')"
   i = index(form,'@')
   form(i:i) = char(ichar('0')+n-1)
   print form,x(1),(x(i),i=2,n)
end subroutine check_eigenvalue
