!  3.2 3̐šŗLlƌŗLxNg
program eigenvalue_3
   implicit none
   real a(3,3),a1(3,3),x(3,3),eigen(3)
   real u,v,w
   real, parameter :: eps = 1e-14
   integer i,j,k,ind,mod3(5)
   a(1,1) = 8;   a(1,2) = -6;   a(1,3) = 2
   a(2,1) = -6;  a(2,2) = 9;    a(2,3) = 4
   a(3,1) = 2;   a(3,2) = 4;    a(3,3) = 12
   u = -(a(1,1) + a(2,2) + a(3,3))
   v = a(1,1)*a(2,2) - a(1,2)*a(2,1) + a(3,3)*a(1,1) - a(1,3)*a(3,1) &
            + a(2,2)*a(3,3) - a(2,3)*a(3,2)
   w = a(1,3)*a(2,2)*a(3,1)+a(2,3)*a(3,2)*a(1,1)+a(3,3)*a(1,2)*a(2,1) &
      -a(1,1)*a(2,2)*a(3,3)-a(2,1)*a(3,2)*a(1,3)-a(3,1)*a(1,2)*a(2,3)
   call root_cubic(u,v,w,eigen)
   do i = 1, 5
      mod3(i) = i
      if (i > 3) mod3(i) = i-3
   enddo
   do k = 1, 3
      a1(:,:) = a(:,:)
      a1(1,1) = a1(1,1) - eigen(k)
      a1(2,2) = a1(2,2) - eigen(k)
      a1(3,3) = a1(3,3) - eigen(k)
 out: do j = 1, 3
         do i = 1, 3
            call eigenvector_3(a1,mod3(i),mod3(j),eps,x(1,k),ind)
            if (ind == 0) exit out
         enddo
      enddo out
   enddo
   call check_eigenvalue(a,eigen(1),x(1,1),3)
   call check_eigenvalue(a,eigen(2),x(1,2),3)
   call check_eigenvalue(a,eigen(3),x(1,3),3)
end program eigenvalue_3

subroutine root_cubic(a,b,c,x)
   implicit none
   real, parameter :: sq3 = 1.732050807568877
   real a,b,c,x(3),q,r,t,cc,ss
   q = (a*a - 3*b)/9
   r = (a*(2*a*a-9*b) + 27*c)/54
   t = acos(r/(sqrt(q)*q))
   q = sqrt(q);   t = t/3;    r = a/3
   cc   = cos(t);    ss = sin(t)
   x(1) =  -(2*q*cc + r)
   x(2) =  q*(cc + ss*sq3) - r
   x(3) =  q*(cc - ss*sq3) - r
end subroutine root_cubic

subroutine eigenvector_3(a,ii,jj,eps,x,ind)
   implicit none
   real a(3,3),eps,x(3),d,s
   integer ii(2),jj(3),i1,i2,j1,j2,j3,ind
   i1 = ii(1);   i2 = ii(2)
   j1 = jj(1);   j2 = jj(2);   j3 = jj(3)
   d = a(i1,j1)*a(i2,j2)-a(i2,j1)*a(i1,j2)
   if (abs(d) < eps) then
      ind = 1
      return
   endif
   x(j1) = -(a(i1,j3)*a(i2,j2)-a(i2,j3)*a(i1,j2))/d
   x(j2) = -(a(i1,j1)*a(i2,j3)-a(i2,j1)*a(i1,j3))/d
   x(j3) = 1
   s = 1/sqrt(x(1)**2+x(2)**2+x(3)**2)
   x(1) = x(1)*s;   x(2) = x(2)*s;   x(3) = x(3)*s
   ind  = 0
end subroutine eigenvector_3

subroutine check_eigenvalue(a,eigen,x,n)
   implicit none
   real a(n,n),eigen,x(n),xe,err
   integer n,i,j
   character(80) form
   err = 0
   do i = 1, n
      xe = 0
      do j = 1, n
         xe = xe + a(i,j)*x(j)
      enddo
      err = max(err,abs(eigen*x(i)-xe))
   enddo
   print "('  Eigenvalue  = ',f14.7,'   Error = ',es11.4)",eigen,err
   form = "('  Eigenvector = (',f12.5,@(',',f12.5),')')"
   i = index(form,'@')
   form(i:i) = char(ichar('0')+n-1)
   print form,x(1),(x(i),i=2,n)
end subroutine check_eigenvalue
