!  3.6 nEXz_[ϊɂΏ̍s3dΊp
program Hauseholder_transform
   implicit none
   integer, parameter :: n0 = 5
   real a(n0,n0),al(n0),be(n0),x(n0),y(n0),z(n0)
   integer i,j
   a(1,1) = 1;  a(1,2) = 1;  a(1,3) = 1;  a(1,4) = 1;  a(1,5) = 1
                a(2,2) = 2;  a(2,3) = 2;  a(2,4) = 2;  a(2,5) = 2
                             a(3,3) = 3;  a(3,4) = 3;  a(3,5) = 3
                                          a(4,4) = 4;  a(4,5) = 4
                                                       a(5,5) = 5
   call householder(a,n0,al,be)
   print *,'Diagonal Elements'
   print *,al
   print *,'Non-Diagonal Elements'
   print *,be(1:n0-1)
   call random_number(x(1:n0))
   print *,'Original Vector'
   print *,x
   z(1) = al(1)*x(1)+be(1)*x(2)
   do i = 2, n0-1
      z(i) = be(i-1)*x(i-1)+al(i)*x(i)+be(i)*x(i+1)
   enddo
   z(n0) = be(n0-1)*x(n0-1)+al(n0)*x(n0)
   call back_htransform(z,a,n0)
   call back_htransform(x,a,n0)
   do i = 1, n0
      y(i) = 0
      do j = 1, i-1
         y(i) = y(i) + a(j,i)*x(j)
      enddo
      do j = i, n0
         y(i) = y(i) + a(i,j)*x(j)
      enddo
   enddo
   print *,'Back-Transformed Vector'
   print *,y
   print *,'Maximum Difference',maxval(abs(z-y))
end program Hauseholder_transform

subroutine householder(a,n,alpha,beta)
   implicit none
   real a(n,n),alpha(n),beta(n)
   real s,c,d
   integer i,j,n,k,k1
   real, allocatable :: a1(:,:),u(:),p(:)
   allocate ( a1(n,n),u(n),p(n) )
   a1(:,:) = a(:,:)
   do j = 1, n
      a1(j,j) = a(j,j)
      do i = 1, j-1
         a1(i,j) = a(i,j)
         a1(j,i) = a(i,j)
      enddo
   enddo
   do k = 1, n-2
      k1 = k + 1
      s = 0
      do i = k1, n
         u(i) = a1(i,k)
         s = s + u(i)*u(i)
      enddo
      s = sqrt(s)
      alpha(k) = a1(k,k)
      if (s == 0) then
         beta(k)  = 0
         do j = k1, n
            a1(j,k) = 0
         enddo
         cycle
      endif
      if (u(k1) < 0) s = -s
      u(k1) = u(k1) + s
      beta(k)  = -s
      c = 1/sqrt(u(k1)*s)
      u(k1:n) = u(k1:n)*c
      do i = k1, n
         p(i) = 0
         do j = k1, n
            p(i) = p(i) + a1(i,j)*u(j)
         enddo
      enddo
      d = 0
      do i = k1, n
         d = d + p(i)*u(i)
      enddo
      d = d/2
      do i = k1, n
         p(i) = p(i) - d*u(i)
      enddo
      do j = k1, n
         a1(j,k) = u(j)
         do i = k1, n
            a1(i,j) = a1(i,j) - (u(i)*p(j) + u(j)*p(i))
         enddo
      enddo
   enddo
   alpha(n-1) = a1(n-1,n-1)
   beta(n-1)  = a1(n,n-1)
   alpha(n)   = a1(n,n)
   do j = 1, n-1
      do i = j+1, n
         a(i,j) = a1(i,j)
      enddo
   enddo
   deallocate ( a1,u,p )
end subroutine householder

subroutine back_htransform(x,a,n)
   implicit none
   real x(n),a(n,n)
   real p1
   integer n,i,j
   do j = n-2, 1, -1
      p1 = 0
      do i = j+1, n
         p1 = p1 + a(i,j)*x(i)
      enddo
      do i = j+1, n
         x(i) = x(i) - p1*a(i,j)
      enddo
   enddo
end subroutine back_htransform
