!  4.4 WhEKEXϕ
!      W쐬pTu[`
program Legendre_Coefficients
   implicit none
   integer, parameter :: n = 7, itmax = 30
   real, parameter :: pi = 3.141592653589793, eps = 1e-25
   real leposition((n+1)/2),leweight((n+1)/2)
   real(16) x,x1,p,dp,w
   integer k,it,n2
   n2 = (n+1)/2
   do k = 1, n2
      x = sin((n+1-2*k)*pi/(2*n+1))
      do it = 1, itmax
         call legendre(n,x,p,dp)
         x1 = x - p/dp
         if (abs(x1-x) < eps .and. abs(p) < eps) exit
         x = x1
      enddo
      if (it > itmax) then
         print *,'No convergence at k = ',k
         stop
      endif
      call legendre(n-1,x,w,dp)
      w = 2*(1-x*x)/(n*w)**2
      leposition(n2+1-k) = x
      leweight(n2+1-k) = w
   enddo
   open(10,file='legendre.inc')
   write(10,*) '   integer, parameter :: narray =',n2
   call output_array(10,leposition,n2,'leposition(narray)')
   call output_array(10,leweight,n2,'leweight(narray)')
end program Legendre_Coefficients

subroutine legendre(n,x,p,dp)
   implicit none
   real(16) x,p,dp,p0,p1,p2
   integer k,n
   p0 = 1
   p1 = x
   do k = 2, n
      p2 = ((2*k-1)*x*p1 - (k-1)*p0)/k
      p0 = p1
      p1 = p2
   enddo
   p  = p1
   dp = n*(p0 - x*p1)/(1-x*x)
end subroutine legendre

subroutine output_array(ndev,array,nd,chd)
   implicit none
   real array(*)
   integer ndev,nd,n4,n0,k
   character chd*(*)
   n4 = mod(nd+3,4) + 1
   n0 = nd - n4
   write(ndev,*) '   real :: ',trim(chd),' = (/ &'
   if (n0 > 0) write(ndev,600) (array(k), k=1,n0)
   if (n4 == 1) then
      write(ndev,610) array(n0+1)
    else if (n4 == 2) then
      write(ndev,620) array(n0+1),array(n0+2)
    else if (n4 == 3) then
      write(ndev,630) array(n0+1),array(n0+2),array(n0+3)
    else
      write(ndev,640) array(n0+1),array(n0+2),array(n0+3),array(n0+4)
   endif
600 format('     ',4(es22.15,', '),' &')
610 format('     ',es22.15,' /)')
620 format('     ',es22.15,', ',es22.15,' /)')
630 format('     ',2(es22.15,', '),es22.15,' /)')
640 format('     ',3(es22.15,', '),es22.15,' /)')
end subroutine output_array
