!  4.5 Q[EKEXϕ@\Ԃ̐ϕ\
!      W쐬pTu[`
program Laguerre_Coefficients
   implicit none
   integer, parameter :: n = 7, itmax = 30
   real, parameter :: pi = 3.141592653589793, eps = 1e-25
   real laposition(n),laweight(n)
   real(16) x,xx,p,dp,w,x1,x2,x3
   integer k,it
   do k = 1, n
      if (k < 4) then
         x = (pi*(k-0.25))**2/(4*n)
       else
         x  = 3*(x3-x2)+x1
         x1 = x2
         x2 = x3
         x3 = x
      endif
      do it = 1, itmax
         call laguerre(n,x,p,dp)
         xx = x - p/dp
         if (abs(xx-x) < eps .and. abs(p) < eps) exit
         x = xx
      enddo
      if (it > itmax) then
         print *,'No convergence at k = ',k
         stop
      endif
      call laguerre(n-1,x,w,dp)
      w = x/(n*w)**2
      if (k == 1) then
         x1 = x
       else if (k == 2) then
         x2 = x
       else
         x3 = x
      endif
      laposition(k) = x
      laweight(k) = w
   enddo
   open(10,file='laguerre.inc')
   write(10,*) '   integer, parameter :: narray =',n
   call output_array(10,laposition,n,'laposition(narray)')
   call output_array(10,laweight,n,'laweight(narray)')
end program Laguerre_Coefficients

subroutine laguerre(n,x,p,dp)
   implicit none
   real(16) x,p,dp,p0,p1,p2
   integer k,n
   p0 = 1
   p1 = 1-x
   do k = 2, n
      p2 = ((2*k-1-x)*p1 - (k-1)*p0)/k
      p0 = p1
      p1 = p2
   enddo
   p  = p1
   dp = n*(p1 - p0)/x
end subroutine laguerre

subroutine output_array(ndev,array,nd,chd)
   implicit none
   real array(*)
   integer ndev,nd,n4,n0,k
   character chd*(*)
   n4 = mod(nd+3,4) + 1
   n0 = nd - n4
   write(ndev,*) '   real :: ',trim(chd),' = (/ &'
   if (n0 > 0) write(ndev,600) (array(k), k=1,n0)
   if (n4 == 1) then
      write(ndev,610) array(n0+1)
    else if (n4 == 2) then
      write(ndev,620) array(n0+1),array(n0+2)
    else if (n4 == 3) then
      write(ndev,630) array(n0+1),array(n0+2),array(n0+3)
    else
      write(ndev,640) array(n0+1),array(n0+2),array(n0+3),array(n0+4)
   endif
600 format('     ',4(es22.15,', '),' &')
610 format('     ',es22.15,' /)')
620 format('     ',es22.15,', ',es22.15,' /)')
630 format('     ',2(es22.15,', '),es22.15,' /)')
640 format('     ',3(es22.15,', '),es22.15,' /)')
end subroutine output_array
