!  4.8 `̈̏dϕ̌vZ
program legendre2d_test
   implicit none
   external func
   real func,ax,bx,ay,by,s
   ax = -2
   bx = 3
   ay = -2
   by = 5
   call Legendre_Gauss_2d(func,ax,bx,ay,by,s)
   print *,'S = ',s
end program legendre2d_test

function func(x,y)
   implicit none
   real func,x,y
   func = x**12 - 15*x**2*y**8 - 4*x**2*y**3 + 2*x + 5*y**2
end function func

subroutine Legendre_Gauss_2d(fun,ax,bx,ay,by,s)
   implicit none
   include 'legendre.inc'            ! t@C}
   real fun,ax,bx,ay,by,s,s0,sx,x1,x2,cx1,cx2,y1,y2,cy1,cy2
   integer kx,ky,n1
   if (ax == bx .or. ay == by) then
      s = 0
      return
   endif
   cx1 = (bx-ax)/2
   cx2 = (bx+ax)/2
   cy1 = (by-ay)/2
   cy2 = (by+ay)/2
   if (leposition(1) == 0) then
      sx = 0
      do kx = 2, narray
         x1 =  cx1*leposition(kx)+cx2
         x2 = -cx1*leposition(kx)+cx2
         sx = sx + leweight(kx)*(fun(x1,cy2)+fun(x2,cy2))
      enddo
      s0 = leweight(1)*(sx + leweight(1)*fun(cx2,cy2))
      sx = 0
      do ky = 2, narray
         y1 =  cy1*leposition(ky)+cy2
         y2 = -cy1*leposition(ky)+cy2
         sx = sx + leweight(ky)*(fun(cx2,y1)+fun(cx2,y2))
      enddo
      s0 = s0 + leweight(1)*sx
      n1 = 2
    else
      s0 = 0
      n1 = 1
   endif
   do ky = n1, narray
      y1 =  cy1*leposition(ky)+cy2
      y2 = -cy1*leposition(ky)+cy2
      sx = 0
      do kx = n1, narray
         x1 =  cx1*leposition(kx)+cx2
         x2 = -cx1*leposition(kx)+cx2
         sx = sx + leweight(kx)*(fun(x1,y1)+fun(x2,y1) &
                               + fun(x1,y2)+fun(x2,y2))
      enddo
      s0 = s0 + leweight(ky)*sx
   enddo
   s = s0*cx1*cy1
end subroutine Legendre_Gauss_2d
