!  5.1 `
program linear_interporation_test
   implicit none
   integer, parameter :: n0 = 20
   real xp(0:n0),yp(0:n0)
   real x,y,z,h
   integer i,n
   h = 6.0/n0
   do i = 0, n0
      xp(i) = i*h
      yp(i) = (xp(i)+1)*cos(2*xp(i))
   enddo
   n = 100
   h = (xp(n0)-xp(0))/n
   call linear_interporation(x,y,xp,yp,n0,1)
   do i = 0, n
      x = h*i + xp(0)
      call linear_interporation(x,y,xp,yp,n0,0)
      z = (x+1)*cos(2*x)
      print *,x,y,z
   enddo
end program linear_interporation_test

subroutine linear_interporation(x,y,xp,yp,n,mode)
   implicit none
   real x,y,xp(0:n),yp(0:n)
   real, allocatable, save :: x0(:),y0(:),a(:)
   integer n,mode,i1,i2,i
   integer, save :: nmax
   if (mode == 1) then
      if (allocated (a)) deallocate ( x0, y0, a )
      allocate ( x0(0:n), y0(0:n-1), a(0:n-1) )
      do i = 0, n-1
         x0(i) = xp(i)
         y0(i) = yp(i)
         a(i)  = (yp(i+1)-yp(i))/(xp(i+1)-xp(i))
      enddo
      x0(n) = xp(n)
      nmax  = n
      return
   endif
   if (x < x0(1)) then
      i1 = 0
      if (x < x0(0)) print *,'Out of bounds -- linear_interporation',x
    else if (x >= x0(nmax-1)) then
      i1 = nmax-1
      if (x > x0(nmax)) print *,'Out of bounds -- linear_interporation',x
    else
      i1 = 1;  i2 = nmax-1
      do while (i2-i1 > 1)
         i = (i1+i2)/2
         if (x < x0(i)) then
            i2 = i
          else
            i1 = i
            if (x == x0(i)) exit
         endif
      enddo
   endif
   y = a(i1)*(x - x0(i1)) + y0(i1)
end subroutine linear_interporation
