!  5.2 3
program cubic_interporation_test
   implicit none
   integer, parameter :: n0 = 12
   real xp(0:n0),yp(0:n0)
   real x,y,z,h
   integer i,n
   h = 6.0/n0
   do i = 0, n0
      xp(i) = i*h
      yp(i) = (xp(i)+1)*cos(2*xp(i))
   enddo
   n = 100
   h = (xp(n0)-xp(0))/n
   call cubic_interporation(x,y,xp,yp,n0,1)
   do i = 0, n
      x = h*i + xp(0)
      call cubic_interporation(x,y,xp,yp,n0,0)
      z = (x+1)*cos(2*x)
      print *,x,y,z
   enddo
end program cubic_interporation_test

subroutine cubic_interporation(x,y,xp,yp,n,mode)
   implicit none
   real x,y,xp(0:n),yp(0:n),d0,d2,d3,s2,s3
   real, allocatable, save :: x1(:),y1(:),a(:),b(:),c(:)
   integer n,mode,i1,i2,i
   integer, save :: nmax
   if (mode == 1) then
      if (allocated (a)) deallocate ( x1, y1, a, b, c )
      allocate ( x1(0:n), y1(0:n-2), a(0:n-2), b(0:n-2), c(0:n-2) )
      do i = 1, n-2
         x1(i) = xp(i)
         y1(i) = yp(i)
         d0 = (yp(i-1)-y1(i))/(xp(i-1)-x1(i))
         d2 = (yp(i+1)-y1(i))/(xp(i+1)-x1(i))
         d3 = (yp(i+2)-y1(i))/(xp(i+2)-x1(i))
         s2 = (d2-d0)/(xp(i+1)-xp(i-1))
         s3 = (d3-d2)/(xp(i+2)-xp(i+1))
         a(i)  = (s3-s2)/(xp(i+2)-xp(i-1))
         b(i)  = s2 - a(i)*(xp(i+1)+xp(i-1)-2*x1(i))
         c(i)  = d2 - (a(i)*(xp(i+1)-x1(i))+b(i))*(xp(i+1)-x1(i))
      enddo
      x1(n-1) = xp(n-1);     x1(n) = xp(n)
      nmax  = n
      return
   endif
   if (x < x1(2)) then
      i1 = 1
      if (x < x1(0)) print *,'Out of bounds -- cubic_interporation',x
    else if (x >= x1(nmax-2)) then
      i1 = nmax-2
      if (x > x1(nmax)) print *,'Out of bounds -- cubic_interporation',x
    else
      i1 = 2;  i2 = nmax-2
      do while (i2-i1 > 1)
         i = (i1+i2)/2
         if (x < x1(i)) then
            i2 = i
          else
            i1 = i
            if (x == x1(i)) exit
         endif
      enddo
   endif
   d0 = x - x1(i1)
   y = ((a(i1)*d0 + b(i1))*d0 + c(i1))*d0 + y1(i1)
end subroutine cubic_interporation
