!  5.5 `FrVFtߎ
program Chebyshev_test
   implicit none
   integer, parameter :: n0 = 31
   real, parameter :: pi  = 3.141592653589793
   real x1,x2
   real x,y,z,h,func
   external func
   integer i,n
   x1 = -2
   x2 = 2
   n = 500
   h = (x2-x1)/n
   call chebyshev_approx(x,y,func,x1,x2,n0,1)
   do i = 0, n
      x = h*i + x1
      z = 1/sqrt(49*x*x + 1)
      call chebyshev_approx(x,y,func,x1,x2,n0,0)
      print *,x,y,z
   enddo
end program Chebyshev_test

function func(x)
   implicit none
   real func,x
   func = 1/sqrt(49*x*x + 1)
end function func

subroutine chebyshev_approx(x,y,func,a,b,n,mode)
   implicit none
   real, parameter :: pi  = 3.141592653589793
   real x,y,func,a,b,c1,c2,w,z
   real tx0,tx1,tx2
   real, allocatable, save :: cs(:),f(:)
   real, save :: xmin,xmax
   integer, save :: nmax
   integer n,mode,k,i
   if (mode /= 0) then
      c1 = (b-a)/2
      c2 = (b+a)/2
      if (allocated(cs)) deallocate (cs)
      allocate ( cs(0:n-1) )
      allocate ( f(n) )
      do k = 1, n
         z = cos(pi*(k-0.5)/n)
         w = c1*z + c2
         f(k) = func(w)
      enddo
      cs(0) = 0
      do k = 1, n
         cs(0) = cs(0) + f(k)
      enddo
      cs(0) = cs(0)/n
      do i = 1, n-1
         cs(i) = 0
         do k = 1, n
            cs(i) = cs(i) + f(k)*cos(pi*i*(k-0.5)/n)
         enddo
         cs(i) = 2*cs(i)/n
      enddo
      deallocate ( f )
      xmin = a
      xmax = b
      nmax = n
      return
   endif
   if (x < xmin) then
      print *,'Out of bounds -- Chebyshev_approx',x
    else if (x > xmax) then
      print *,'Out of bounds -- Chebyshev_approx',x
   endif
   c1 = 2/(xmax-xmin)
   c2 = (xmax+xmin)/2
   z  = (x-c2)*c1
   tx0 = 0;    tx1 = 0
   do i = nmax-1, 1, -1
      tx2 = 2*z*tx1 - tx0 + cs(i)
      tx0 = tx1;  tx1 = tx2
   enddo
   y = z*tx1 - tx0 + cs(0)
end subroutine chebyshev_approx
