!  5.6 K@ɂ镽
program smoothing_test
   implicit none
   integer, parameter :: n0 = 100
   real xp(0:n0),yp(0:n0),ran(0:n0),h
   real yy(0:n0),dy(0:n0)
   integer i
   xp(0) = 0
   xp(n0) = 7
   call random_number(ran(0:n0))
   h = (xp(n0)-xp(0))/n0
   do i = 0, n0
      xp(i) = h*i + xp(0)
      yp(i) = -6 + xp(i)*(25 - xp(i)*(10 - xp(i))) + 20*(ran(i)-0.5)
   enddo
   call smoothing23(yp,yy,dy,n0+1,5)
   dy = dy/h
   do i = 0, n0
      print *,xp(i),yp(i),yy(i),dy(i)
   enddo
end program smoothing_test

subroutine smoothing23(y,ys,yd,n,m)
   implicit none
   real y(n),ys(n),yd(n),sw23,dsw23
   integer n,m,i,j,mc
   real, allocatable, save :: w23(:),dw23(:)
   integer, save :: m0 = -1
   if (m0 /= m) then
      m0 = m
      if (allocated(w23)) deallocate (w23,dw23)
      allocate ( w23(0:m0), dw23(0:m0) )
      mc   = 3*m0*(m0+1)-1
      sw23 = 3.0/((4*m0*m0-1)*(2*m0+3))
      dsw23 = 3.0/(m0*(m0+1)*(2*m0+1))
      do i = 0, m0
         w23(i)  = (mc-5*i*i)*sw23
         dw23(i) = i*dsw23
      enddo
   endif
   do i = 1, m0
      ys(i) = y(i)
      yd(i) = 0
   enddo
   do i = m0+1, n-m0
      ys(i) = w23(0)*y(i)
      yd(i) = 0
      do j = 1, m0
         ys(i) = ys(i) + w23(j)*(y(i+j)+y(i-j))
         yd(i) = yd(i) + dw23(j)*(y(i+j)-y(i-j))
      enddo
   enddo
   do i = n-m0+1, n
      ys(i) = y(i)
      yd(i) = 0
   enddo
end subroutine smoothing23
