!  5.7 ŏ2@
program least_square_test
   implicit none
   integer, parameter :: n0 = 500
   real xp(n0),yp(n0),ran(n0),ck(0:3)
   real x,y,z,h
   integer i,n
   xp(1) = 0
   xp(n0) = 5
   call random_number(ran(1:n0))
   h = (xp(n0)-xp(1))/(n0-1)
   do i = 2, n0
      xp(i) = h*(i-1) + xp(1)
      yp(i) = xp(i)*(1 - xp(i)*(0.5 - xp(i)/14)) + 0.5*(ran(i)-0.5)
   enddo
   call least_square(xp,yp,n0,ck,3)
   print *,ck
   n = 100
   h = (xp(n0)-xp(1))/n
   do i = 0, n
      x = h*i + xp(1)
      y = ck(0) + x*(ck(1) + x*(ck(2) + x*ck(3)))
      z = x-x*x/2+x*x*x/14
      print *,x,y,z
   enddo
end program least_square_test

subroutine least_square(xp,yp,n,ck,m)
   implicit none
   real xp(n),yp(n),ck(m+1)
   integer n,m,m1,i,j
   real, allocatable, save :: a(:,:),b(:)
   m1 = m + 1
   allocate ( a(n,m1), b(n) )
   do i = 1, n
      a(i,1) = 1
      do j = 2, m1
         a(i,j) = xp(i)**(j-1)
      enddo
      b(i) = yp(i)
   enddo
   call qr_householder(a,b,n,m1)
   ck(m1) = b(m1)/a(m1,m1)
   do i = m1-1, 1, -1
      ck(i) = 0
      do j = i+1, m1
         ck(i) = ck(i) + a(i,j)*ck(j)
      enddo
      ck(i) = (b(i) - ck(i))/a(i,i)
   enddo
   deallocate ( a, b )
end subroutine least_square

subroutine qr_householder(a,b,n,m)
   implicit none
   real a(n,m),b(n)
   real s,c,d
   integer n,m,i,j,k
   real, allocatable :: u(:),p(:)
   allocate ( u(n), p(n) )
   do k = 1, m
      s = 0
      do i = k, n
         u(i) = a(i,k)
         s = s + u(i)*u(i)
      enddo
      s = sqrt(s)
      if (s == 0) cycle
      if (u(k) < 0) s = -s
      u(k) = u(k) + s
      c = 1/sqrt(u(k)*s)
      u(k:n) = u(k:n)*c
      do j = k+1, m
         p(j) = 0
         do i = k, n
            p(j) = p(j) + a(i,j)*u(i)
         enddo
      enddo
      a(k,k) = -s
      do j = k+1, m
         do i = k, n
            a(i,j) = a(i,j) - u(i)*p(j)
         enddo
      enddo
      d = 0
      do i = k, n
         d = d + b(i)*u(i)
      enddo
      do i = k, n
         b(i) = b(i) - d*u(i)
      enddo
   enddo
   deallocate ( u, p )
end subroutine qr_householder
