!  6.5 1xbZ֐
program BesselJ_test
   implicit none
   real x,h,besselJ
   integer i,n
   n = 10000
   h = 0.01
   do i = 0, n
      x = h*i
      print 600,x,besselJ(0,x),besselJ(1,x),besselJ(2,x),besselJ(3,x)
   enddo
  600 format(f10.5,4es20.10)
end program BesselJ_test

function besselJ(n,x)
   implicit none
   real x,besselJ,xa,x2,f,g,bj0,bj1,bj2,ja,bj
   real, parameter :: ep = 1d-75
   integer n,na,k,m
   na = abs(n)
   xa = abs(x)
   if (xa < 2e-5) then
      x2 = x/2
      if (na == 0) then
         besselJ = 1 - x2*x2
       else
         f = 1;   g = x2
         do k = 2, na
            f = f*k;    g = g*x2
         enddo
         besselJ = g*(1 - x2*x2/(na+1))/f
      endif
    else
      if (xa <= 1) then
         m = 14
       else if (xa < 10) then
         m = 1.4*xa + 14
       else if (xa < 100) then
         m = 0.27*xa + 27
       else
         m = 0.073*xa + 47
      endif
      m = max(na,int(xa)) + m
      bj0 = 0;    bj1 = ep
      x2 = 2/x
      ja  = 0
      do k = m, na, -1
         bj2 = x2*(k+1)*bj1 - bj0
         bj0 = bj1;     bj1 = bj2
         if (mod(k,2) == 0) ja = ja + bj2
      enddo
      bj = bj2
      if (na > 0) then
         do k = na-1, 0, -1
            bj2 = x2*(k+1)*bj1 - bj0
            bj0 = bj1;     bj1 = bj2
            if (mod(k,2) == 0) ja = ja + bj2
         enddo
      endif
      ja = 2*ja - bj2
      besselJ = bj/ja
   endif
   if (n < 0) then
      if (mod(n,2) /= 0) besselJ = -besselJ
   endif
end function besselJ
