!  6.6 2xbZ֐
program BesselY_test
   implicit none
   real x,h,besselY
   integer i,n,k
   n = 10000
   h = 0.01
   do i = 1, n
      x = h*i
      print 600,x,besselY(0,x),besselY(1,x),besselY(2,x),besselY(3,x)
   enddo
  600 format(f10.5,4es20.10)
end program BesselY_test

function besselY(n,x)
   implicit none
   real x,besselY,xa,x2,bj0,bj1,bj2,bj3,ya,by0,by1,by2,f
   real, parameter :: pi=3.141592653589793, gam = 0.57721566490153286
   real, parameter :: ep = 1d-75
   integer n,na,k,m,ns
   na = abs(n)
   if (x <= 0) then
      besselY = 1d100
      write(*,*) 'Error in function besselY: Negative x = ',x
      return
   endif
   xa = x
   if (xa < 2e-5) then
      x2  = xa/2
      bj0 = 1 - x2*x2
      f   = log(x2) + gam
      by0 = 2/pi*(f*bj0)
      by1 = by0
      if (na >= 1) then
         bj1 = x2
         by1 = 2/pi*((f-1)*bj1 - bj0/xa)
      endif
      x2 = 1/x2
    else
      if (xa < 0.1) then
         m = 10
       else if (xa < 1) then
         m = 17
       else if (xa < 10) then
         m = 2.4*xa + 15
       else if (xa < 100) then
         m = 1.27*xa + 28
       else
         m = 1.073*xa + 47
      endif
      bj0 = 0;       bj1 = ep
      ya  = 0;       by0 = 0;      by1 = 0
      x2 = 2/xa;     ns = 1
      if (mod(m,2) /= 0) m = m + 1
      do k = m, 2, -2
         bj2 = x2*(k+1)*bj1 - bj0
         bj3 = x2* k   *bj2 - bj1
         ns  = -ns
         by0 = by0 + ns*bj2/k
         by1 = by1 + ns*(k+1)*bj1/(k*(k+2))
         ya  = ya + bj2
         bj0 = bj2;      bj1 = bj3
      enddo
      if (ns < 0) then
         by0 = -by0;    by1 = -by1
      endif
      bj2 = x2*bj1 - bj0
      ya  = 2/(pi*(2*ya + bj2))
      f   = log(xa/2) + gam
      by0 = ya*(f*bj2 + 4*by0)
      if (na == 0) then
         by1 = by0
       else
         by1 = ya*((f-1)*bj1 - bj2/xa + 4*by1)
      endif
   endif
   do k = 2, na
      by2 = x2*(k-1)*by1 - by0
      by0 = by1;      by1 = by2
   enddo
   besselY = by1
   if (n < 0) then
      if (mod(n,2) /= 0) besselY = -besselY
   endif
end function besselY
