!  6.7 1ό`xbZ֐
program BesselI_test
   implicit none
   real x,h,besselI
   integer i,n
   n = 10000
   h = 0.001
   do i = 1, n
      x = h*i
      print 600,x,besselI(0,x),besselI(1,x),besselI(2,x),besselI(3,x)
   enddo
  600 format(f10.5,4es20.10)
end program BesselI_test

function besselI(n,x)
   implicit none
   real x,besselI,xa,x2,f,g,bi0,bi1,bi2,bi,ia
   real, parameter :: ep = 1d-75
   integer n,na,k,m
   na = abs(n)
   xa = abs(x)
   if (xa < 2e-8) then
      if (na == 0) then
         besselI = 1
       else if (xa <= 1d-77) then
         besselI = 0
       else
         x2 = xa/2
         f = 1;   g = x2
         do k = 2, na
            f = f*k;    g = g*x2
         enddo
         besselI = g/f
      endif
    else
      if (xa < 0.1) then
         m = 10
       else if (xa < 10) then
         m = 25
       else
         m = 40
      endif
      m = max(na,int(xa)) + m
      bi0 = 0;    bi1 = ep
      x2 = 2/xa
      ia  = 0
      if (na == 0) then
         do k = m, 1, -1
            bi2 = x2*(k+1)*bi1 + bi0
            bi0 = bi1;     bi1 = bi2
            ia = ia + bi2
         enddo
         bi2 = x2*bi1 + bi0
         ia = 2*ia + bi2
         besselI = bi2/ia*exp(xa)
       else
         do k = m, na, -1
            bi2 = x2*(k+1)*bi1 + bi0
            bi0 = bi1;     bi1 = bi2
            ia = ia + bi2
         enddo
         bi = bi2
         do k = na-1, 1, -1
            bi2 = x2*(k+1)*bi1 + bi0
            bi0 = bi1;     bi1 = bi2
            ia = ia + bi2
         enddo
         bi2 = x2*bi1 + bi0
         ia = 2*ia + bi2
         besselI = bi/ia*exp(xa)
      endif
   endif
   if (x < 0) then
      if (mod(n,2) /= 0) besselI = -besselI
   endif
end function besselI
