!  6.10 Rȓȉ~֐
program test_sncndn
   implicit none
      real u,h,k,sn,cn,dn
      integer i,n
      n = 10000
      h = 20.0/n
      k = 0.4
      do i = 0, n
         u = h*i
         call sncndn(u,k,sn,cn,dn)
         print 600,u,k,sn,cn,dn
      enddo
  600 format(2f10.5,3es20.10)
end program test_sncndn

subroutine sncndn(u,k,sn,cn,dn)
   implicit none
   real, parameter :: pi = 3.141592653589793, pi2 = pi*2
   real u,v,k,sn,cn,dn,k2,kd,nome_q,th1,th2,th3,th4
   real z,z2,z4,z6,zi2,zi4,zi6,zi8,cc,cc2,ss,ss2
   real, save :: k2c = 0,q,qd,q2,q3,q4,kk,kkd,kcs,kcc,kcd
   integer ind,nd
   k2 = k*k
   if (k2 == 0) then
      sn = sin(u);    cn = cos(u);       dn = 1
      return
    else if (k2 == 1) then
      sn = tanh(u);   cn = 1/cosh(u);    dn = cn
      return
    else if (k2 > 0.5) then
      if (k2c /= k2) then
         q = nome_q(1-k2)
         qd = 2*sqrt(sqrt(q))
         q2 = q*q;      q3 = q2*q;   q4 = q2*q2
         kk  = 0.5*(1 + 2*q*(1 + q3*(1 + q3*q2)))**2
         kkd = pi*kk
         kk  = -log(q)*kk
         kd  = sqrt(1-k2)
         kcs = 1/sqrt(k);     kcd = sqrt(kd)
         kcc = kcs*kcd
         k2c = k2
      endif
      ind = 0
      nd  = u/(4*kk)
      z   = u - 4*kk*nd
      if (z > 2*kk) then
         z = z - 4*kk
       else if (z < -2*kk) then
         z = z + 4*kk
      endif            
      if (z < -kk) then
         ind = 1
         z = z + 2*kk
       else if (z > kk) then
         ind = 1
         z = z - 2*kk
      endif
      v = z/(2*kkd)
      z = exp(pi*v)
      z2 = z*z;   z4 = z2*z2;   z6 = z2*z4
      zi2 = 1/z2;  zi4 = zi2*zi2;  zi6 = zi2*zi4;   zi8 = zi4*zi4
!     th1 = qd*(sinh(pi*v) - q2*(sinh(3*pi*v) - q4*sinh(5*pi*v)))
      th1 = qd*z*((1-zi2)-q2*((z2-zi4)-q4*((z4-zi6)-q4*q2*(z6-zi8))))/2
!     th4 = qd*(cosh(pi*v) + q2*(cosh(3*pi*v) + q4*cosh(5*pi*v)))
      th4 = qd*z*((1+zi2)+q2*((z2+zi4)+q4*((z4+zi6)+q4*q2*(z6+zi8))))/2
      z4 = 1 + q4*(z4+zi4)
      z2 = q*((z2+zi2)+q4*q4*(z6+zi6))
!     th3 = 1 + 2*(q*cosh(2*pi*v)+q**4*cosh(4*pi*v)+q**9*cosh(6*pi*v))
      th3 = z4 + z2
!     th4 = 1 - 2*(q*cosh(2*pi*v)-q**4*cosh(4*pi*v)+q**9*cosh(6*pi*v))
      th2 = z4 - z2
      if (ind > 0) then
         th1 = -th1;    th2 = -th2
      endif
    else
      if (k2c /= k2) then
         q  = nome_q(k2)
         qd = 2*sqrt(sqrt(q))
         q2 = q*q;      q3 = q2*q;     q4 = q2*q2
         kk = 0.5*pi*(1 + 2*q*(1 + q3*(1 + q3*q2)))**2
         kd = sqrt(1 - k2)
         kcs = 1/sqrt(k);     kcd = sqrt(kd)
         kcc = kcs*kcd
         k2c = k2
      endif
      v = u/(2*kk)
      cc = cos(pi*v);      cc2 = cc*cc
      ss = sin(pi*v);      ss2 = ss*ss
!     th1 = qd*(sin(pi*v) - q2*(sin(3*pi*v) - q4*sin(5*pi*v)))
      th1 = qd*(ss - q2*ss*((3-4*ss2) - q4*(5-ss2*(20-16*ss2))))
!     th2 = qd*(cos(pi*v) + q2*(cos(3*pi*v) + q4*cos(5*pi*v)))
      th2 = qd*(cc + q2*cc*((4*cc2-3) + q4*(5-cc2*(20-16*cc2))))
      z4 = 1 + 2*q4*(1-8*cc2*(1-cc2))
      z2 = 2*q*(cc2-ss2 - q4*q4*(1 - cc2*(18-cc2*(48-32*cc2))))
!     th3 = 1 + 2*(q*cos(2*pi*v)+q**4*cos(4*pi*v)+q**9*cos(6*pi*v))
      th3 = z4 + z2
!     th4 = 1 - 2*(q*cos(2*pi*v)-q**4*cos(4*pi*v)+q**9*cos(6*pi*v))
      th4 = z4 - z2
   endif
   sn = kcs*th1/th4
   cn = kcc*th2/th4
   dn = kcd*th3/th4
end subroutine sncndn

function nome_q(k2)
   implicit none
   real nome_q,k2,kd,ep,ep4
   if (k2 == 0) then
      nome_q = 0
    else
      kd = sqrt(1 - k2)
      ep = 0.5*k2/((1+2*sqrt(kd)+kd)*(1+kd))
      ep4 = ep*ep
      ep4 = ep4*ep4
      nome_q = ep*(1 + ep4*(2+ep4*(15+ep4*150)))
   endif
end function nome_q
