!  7.3 x̍l̉@@\QENb^@\
program runge_kutta_test
   implicit none
   real x0,p(2),h,y0,z0
   integer n,nmax
   external funcyz
   x0 = 0
   y0 = 1
   z0 = 0
   p(1) = y0
   p(2) = z0
   h  = 0.1
   nmax = 30
   print *,'x, y, z = ',x0,y0,z0
   do n = 1, nmax
      call runge_kutta(funcyz,2,x0,h,p) 
      y0 = p(1)
      z0 = p(2)
      print *,'x, y, z = ',x0,y0,z0
   enddo
end program runge_kutta_test

subroutine funcyz(m,x,y,f)
   implicit none
   real x,y(m),f(m)
   integer m
   f(1) = - y(1) - 5*y(2) 
   f(2) = 4*y(1) - 3*y(2) 
end subroutine funcyz

subroutine runge_kutta(func,m,xn,h,yn)
   implicit none
   real xn,h,yn(m),k1(m),ys(m),dy(m)
   integer m,i
   call func(m,xn,yn,k1)
   do i = 1, m
      ys(i) = yn(i) + (h/2)*k1(i)
      dy(i) = k1(i)
   enddo
   call func(m,xn+h/2,ys,k1)
   do i = 1, m
      ys(i) = yn(i) + (h/2)*k1(i)
      dy(i) = dy(i) + 2*k1(i)
   enddo
   call func(m,xn+h/2,ys,k1)
   do i = 1, m
      ys(i) = yn(i) + h*k1(i)
      dy(i) = dy(i) + 2*k1(i)
   enddo
   call func(m,xn+h,ys,k1)
   do i = 1, m
      yn(i) = yn(i) + (h/6)*(dy(i) + k1(i))
   enddo
   xn = xn + h
end subroutine runge_kutta
