!  7.4 ݕߌvZ@\QENb^EtF[xO@\
program rk_fehlberg_test
   implicit none
   real x0,y(2),h,eps
   integer n,nmax,ndiv,nstep
   external func2d
   x0 = 0
   y(1) = 0
   y(2) = 0.36514
   h    = 0.1
   eps  = 5.e-8
   nmax = 150
   nstep = 0
   print *,'x, y, ndiv = ',x0,y(1),ndiv
   do n = 1, nmax
      call rk_fehlberg(func2d,2,x0,h,y,eps,ndiv)
      nstep = nstep + ndiv
      print *,'x, y, ndiv = ',x0,y(1),ndiv
   enddo
end program rk_fehlberg_test

subroutine func2d(m,x,y,f)
   implicit none
   real x,y(m),f(m)
   integer m
   f(1) = y(2)
   f(2) = -sin(30*y(1))
end subroutine func2d

subroutine rk_fehlberg(func,m,xn,h,yn,eps,ndiv)
   implicit none
   real xn,h,eps,yn(m),yn1(m),dyn(m)
   real absmax,beta,xn0
   integer m,ndiv,i,nd
   external func
   xn0 = xn
   call rkf_single_step(func,m,xn,h,yn,yn1,dyn)
   absmax = 0
   do i = 1, m
      absmax = max(absmax, abs(dyn(i)))
   enddo
   beta = 0.9*(eps/absmax)**0.2
   if (beta > 1.0) then
      ndiv = 1
      do i = 1, m
         yn(i) = yn1(i)
      enddo
    else
      ndiv = 10-1.0/beta
      if (ndiv <= 0) then
         ndiv = 10
       else
         ndiv = 10-ndiv
      endif
      do nd = 1, ndiv
         call rkf_single_step(func,m,xn,h/ndiv,yn,yn1,dyn)
         xn = xn + h/ndiv
         do i = 1, m
            yn(i) = yn1(i)
         enddo
      enddo
   endif
   xn = xn0 + h
end subroutine rk_fehlberg

subroutine rkf_single_step(func,m,xn,h,yn,yn1,dyn)
   implicit none
   real xn,h,yn(m),k1(m),k2(m),k3(m),k4(m),k5(m)
   real yn1(m),dyn(m)
   integer m,i
   call func(m,xn,yn,k1)
   do i = 1, m
      dyn(i) = yn(i) + (h/4)*k1(i)
   enddo
   call func(m,xn+h/4,dyn,k2)
   do i = 1, m
      dyn(i) = yn(i) + (h/32)*(3*k1(i)+9*k2(i))
   enddo
   call func(m,xn+3*h/8,dyn,k3)
   do i = 1, m
      dyn(i) = yn(i) + (h/2197)*(1932*k1(i)-7200*k2(i)+7296*k3(i))
   enddo
   call func(m,xn+12*h/13,dyn,k4)
   do i = 1, m
      dyn(i) = yn(i) + h*(439*k1(i)/216-8*k2(i)+3680*k3(i)/513 &
                                        -845*k4(i)/4104)
   enddo
   call func(m,xn+h,dyn,k5)
   do i = 1, m
      dyn(i) = yn(i) + h*(-8*k1(i)/27+2*k2(i)-3544*k3(i)/2565 &
                            +1859*k4(i)/4104-11*k5(i)/40)
   enddo
   call func(m,xn+h/2,dyn,k2)
   do i = 1, m
      yn1(i) = yn(i) + h*(16*k1(i)/135+6656*k3(i)/12825 &
                   +28561*k4(i)/56430-9*k5(i)/50+2*k2(i)/55)
      dyn(i) = h*(k1(i)/360-128*k3(i)/4275-2197*k4(i)/75240 &
                            +k5(i)/50+2*k2(i)/55)
   enddo
end subroutine rkf_single_step
