!  7.8 2_El̉@@\V[eBO@\
program lane_emden_equation
   implicit none
   real r0,y(4),h,rmax,y0,y1,eps
   integer n,nmax,it,itmax
   external lane_emden
   itmax = 30
   eps  = 1e-10
   rmax = 5
   y0   = 1
   nmax = 200
   h  = rmax/nmax
   do it = 1, itmax
      r0   = 0
      y(1) = y0
      y(2) = 0
      y(3) = 1
      y(4) = 0
      do n = 1, nmax
         call runge_kutta(lane_emden,4,r0,h,y)
      enddo
      y1 = y0 - y(1)/y(3)
      if (abs(y1-y0) < eps) exit
      y0 = y1
   enddo
   r0   = 0
   y(1) = y0
   y(2) = 0
   print *,r0,y(1),y(2)
   do n = 1, nmax
      call runge_kutta(lane_emden,2,r0,h,y)
      print *,r0,y(1),y(2)
   enddo
end program lane_emden_equation

subroutine lane_emden(m,r,y,f)
   implicit none
   real r,y(m),f(m),r2
   integer m
   r2 = r*r
   f(1) = 0
   if (r > 0) f(1) = y(2)/r2
   f(2) = -r2*y(1)**3
   if (m == 2) return
   f(3) = 0
   if (r > 0) f(3) = y(4)/r2
   f(4) = -3*y(1)**2*r2*y(3)
end subroutine lane_emden

subroutine runge_kutta(func,m,xn,h,yn)
   implicit none
   real xn,h,yn(m),k1(m),ys(m),dy(m)
   integer m,i
   call func(m,xn,yn,k1)
   do i = 1, m
      ys(i) = yn(i) + (h/2)*k1(i)
      dy(i) = k1(i)
   enddo
   call func(m,xn+h/2,ys,k1)
   do i = 1, m
      ys(i) = yn(i) + (h/2)*k1(i)
      dy(i) = dy(i) + 2*k1(i)
   enddo
   call func(m,xn+h/2,ys,k1)
   do i = 1, m
      ys(i) = yn(i) + h*k1(i)
      dy(i) = dy(i) + 2*k1(i)
   enddo
   call func(m,xn+h,ys,k1)
   do i = 1, m
      yn(i) = yn(i) + (h/6)*(dy(i) + k1(i))
   enddo
   xn = xn + h
end subroutine runge_kutta
