!  8.2 1M`̉@2@\A@\
program thermal_implicit
   implicit none
   integer, parameter :: imax = 100
   real T(0:imax),Td(0:imax),xmax,x,dx,dt,kp,kdt
   real at,bt
   integer i,nt,ntmax
   kp   = 1
   xmax = 10
   dx   = xmax/imax
   dt   = 0.1
   kdt  = kp*dt/(dx*dx)
   ntmax = 100
   at    = -0.5*kdt
   bt    = 1 + kdt
   do i = 0, imax
      x = dx*i
      if (i < imax/2) then
         T(i) = x
       else
         T(i) = xmax - x
      endif
      write(10,*) i,x,T(i)
   enddo
   do nt = 1, ntmax
      do i = 1, imax-1
         Td(i) = T(i) + 0.5*kdt*(T(i-1) - 2*T(i) + T(i+1))
      enddo
      call tridiagonal_abc(at,bt,at,Td,imax,T)
   enddo
   do i = 0, imax
      x = dx*i
      write(11,*) i,x,T(i)
   enddo
   print *,'Stored Initial Data -> 10'
   print *,'Stored Final   Data -> 11'
end program thermal_implicit

subroutine tridiagonal_abc(a,b,c,d,n,x)
   implicit none
   real a,b,c,d(0:n),x(0:n)
   real G(n),H(n),den
   integer i,n
   G(1) = -c/b
   H(1) = d(1)/b
   do i = 2, n-1
      den  = 1/(b + a*G(i-1))
      G(i) = -c*den
      H(i) = (d(i) - a*H(i-1))*den
   enddo
   x(n-1) = H(n-1)
   do i = n-2, 1, -1
      x(i) = G(i)*x(i+1) + H(i)
   enddo
end subroutine tridiagonal_abc
