!  8.7 2|A\̔@1@\Rr@\
program Poisson_Jacobi
   implicit none
   integer, parameter :: nx = 200, ny = 200
   real V(0:nx,0:ny),f(0:nx,0:ny),x,y,h
   integer i,j,ind
   real, parameter :: pi = 3.141592653589793, eps = 1e-8
   h = 1.0/nx
   do j = 0, ny
      y = h*j
      do i = 0, nx
         x = h*i
         V(i,j) = 0
         f(i,j) = cos(pi*x)*cos(3*pi*y) + sin(2*pi*x)*sin(4*pi*y)
      enddo
   enddo
   call jacobi(V,f,h,nx,ny,eps,ind)
   print *,'ind = ',ind

   write(10,*) nx,ny,ind
   do j = 0, ny
      do i = 0, nx
         write(10,*) i,j,V(i,j)
      enddo
   enddo
   print *,'Stored Data -> 10'
end program Poisson_Jacobi

subroutine jacobi(V,f,h,nx,ny,eps,ind)
   implicit none
   real V(0:nx,0:ny),f(0:nx,0:ny),h,eps,del,h2
   real,allocatable :: V2(:,:)
   integer nx,ny,ind,i,j,it
   integer, parameter :: itmax = 100000
   allocate ( V2(nx-1,ny-1) )
   h2 = h*h
   do it = 1, itmax
      do j = 1, ny-1
         do i = 1, nx-1
            V2(i,j) = (V(i,j-1) + V(i-1,j) + V(i+1,j) &
                                    + V(i,j+1) - h2*f(i,j))/4
         enddo
      enddo
      V(1:nx-1,1:ny-1) = V2(:,:)
      del = 0
      do j = 1, ny-1
         do i = 1, nx-1
            del = max(del, abs(V(i-1,j)+V(i+1,j)+V(i,j-1)+V(i,j+1) &
                                 -4*V(i,j) - h2*f(i,j)))
         enddo
      enddo
      del = del/h2
      if (del < eps) exit
   enddo
   if (it > itmax) then
      ind = -itmax
    else
      ind = it
   endif
   deallocate (V2)
end subroutine jacobi
