!  8.8 2|A\̔@2@\KEXEUCf@{SOR\
program Poisson_RB_Gauss_Seidel
   implicit none
   integer, parameter :: nx = 200, ny = 200
   real V(0:nx,0:ny),f(0:nx,0:ny),x,y,dx,dy
   integer i,j,ind
   real, parameter :: pi = 3.141592653589793, eps = 1e-8
   dx = 1.0/nx;      dy = dx
   do j = 0, ny
      y = dy*j
      do i = 0, nx
         x = dx*i
         V(i,j) = 0
         f(i,j) = cos(pi*x)*cos(3*pi*y) + sin(2*pi*x)*sin(4*pi*y)
      enddo
   enddo
   call rbgs_sor(V,f,dx,nx,ny,1.94,eps,ind)
   print *,'ind = ',ind
   write(10,*) nx,ny,ind
   do j = 0, ny
      do i = 0, nx
         write(10,*) i,j,V(i,j)
      enddo
   enddo
   print *,'Stored Data -> 10'
end program Poisson_RB_Gauss_Seidel

subroutine rbgs_sor(V,f,h,nx,ny,omega,eps,ind)
   implicit none
   real V(0:nx,0:ny),f(0:nx,0:ny),h,omega,eps,h2
   real del,ff
   integer nx,ny,ind,i,j,it,nrb,irb
   integer, parameter :: itmax = 100000
   h2 = h*h
   do it = 1, itmax
      do nrb = 1, 2
         do j = 1, ny-1
            irb = mod(j+nrb,2)+1
            do i = irb, nx-1, 2
               ff = V(i,j)
               V(i,j) = (V(i,j-1) + V(i-1,j) + V(i+1,j) &
                                    + V(i,j+1) - h2*f(i,j))/4
               V(i,j) = ff + omega*(V(i,j)-ff)
            enddo
         enddo
      enddo
      del = 0
      do j = 1, ny-1
         do i = 1, nx-1
            del = max(del, abs(V(i-1,j)+V(i+1,j)+V(i,j-1)+V(i,j+1) &
                                 -4*V(i,j) - h2*f(i,j)))
         enddo
      enddo
      del = del/h2
      if (del < eps) exit
   enddo
   if (it > itmax) then
      ind = -itmax
    else
      ind = it
   endif
end subroutine rbgs_sor
