!  9.1 Ut[Gϊ
program dft_test
   implicit none
   integer, parameter :: nmax = 200
   real, parameter :: pi = 3.141592653589793, pi2 = 2*pi
   complex cf(0:nmax-1)
   real x,ak
   integer j,k,n
   do j = 0, nmax-1
      ak = pi2*j/nmax
      do k = 0, nmax-1
         x = ak*k
         cf(k) = cmplx(cos(x),sin(x))
      enddo
      call cdft(cf,nmax,-1)
      do n = 0, nmax-1
         if (abs(cf(n)) > 1e-12) print *,j,n,cf(n)
      enddo
   enddo
end program dft_test

subroutine cdft(cf,n0,mode)
   implicit none
   integer n0,mode,i,j,it
   complex cf(0:n0-1)
   integer, save :: ns = 0
   real, parameter :: pi = 3.141592653589793, pi2 = 2*pi
   complex, allocatable, save :: cwp(:,:)
   complex, allocatable :: cf1(:)
   real x,ak
   if (ns /= n0) then
      ns = n0
      if (allocated(cwp)) deallocate ( cwp )
      allocate ( cwp(0:ns-1,2) )
      ak = pi2/ns
      do i = 0, ns-1
         x = ak*i
         cwp(i,1) = cmplx(cos(x), sin(x))
         cwp(i,2) = conjg(cwp(i,1))
      enddo
   endif
   allocate ( cf1(0:ns-1) )
   if (mode < 0) then
      it = 2
    else
      it = 1
   endif
   cf1(:) = cf(:)
   do i = 0, ns-1
      cf(i) = cf1(0)
      do j = 1, ns-1
         cf(i) = cf(i) + cwp(mod(j*i,ns),it)*cf1(j)
      enddo
   enddo
   if (mode == 2 .or. mode == -1) cf(:) = cf(:)/ns
   deallocate ( cf1 )
end subroutine cdft
