!  9.2 t[Gϊ
program fft_ST_test
   implicit none
   integer, parameter :: mmax = 8, nmax = 2**mmax
   real, parameter :: pi = 3.141592653589793, pi2 = 2*pi
   complex cf(0:nmax-1)
   real x,ak
   integer j,k,n
   do j = 0, nmax-1
      ak = pi2*j/nmax
      do k = 0, nmax-1
         x = ak*k
         cf(k) = cmplx(cos(x),sin(x))
      enddo
      call cfft(cf,nmax,-1)
      do n = 0, nmax-1
         if (abs(cf(n)) > 1e-12) print *,j,n,cf(n)
      enddo
   enddo
end program fft_ST_test

subroutine cfft(cf,n0,mode)
   implicit none
   integer n0,mode,i,i1,j,k,n1,n2,ir,it
   complex cf(0:n0-1),c1,c2
   integer, save :: ms, ns = 0, nr
   real, parameter :: pi = 3.141592653589793, pi2 = 2*pi
   complex, allocatable, save :: cwp(:,:)
   integer, allocatable, save :: irev1(:),irev2(:)
   real x,ak
   if (ns /= n0) then
      ms = 0
      ns = n0
      do i = 1, n0
         if (mod(ns,2) /= 0) then
            print *,'N0 must be 2**m',n0
            return
         endif
         ns = ns/2
         ms = ms + 1
         if (ns <= 1) exit
      enddo
      ns = n0
      if (allocated(cwp)) deallocate ( cwp, irev1, irev2 )
      allocate ( cwp(0:n0/2-1,2), irev1(n0/2), irev2(n0/2) )
      ak = pi2/n0
      do i = 0, n0/2-1
         x = ak*i
         cwp(i,1) = cmplx(cos(x), sin(x))
         cwp(i,2) = conjg(cwp(i,1))
      enddo
      nr = 0
      do i = 1, n0-1
         n1 = i
         ir = 0
         do j = 1, ms
            ir = ir*2 + mod(n1,2)
            n1 = n1/2
         enddo
         if (i < ir) then
            nr = nr + 1
            irev1(nr) = i
            irev2(nr) = ir
         endif
      enddo
   endif
   if (mode < 0) then
      it = 2
    else
      it = 1
   endif
   n1 = 1
   n2 = n0
   do k = 1, ms-1
      n2 = n2/2
      do j = 0, n1-1
         do i = 0, n2-1
            i1 = i + j*n2*2
            c1 = cf(i1)
            c2 = cf(i1+n2)
            cf(i1)    = c1 + c2
            cf(i1+n2) = (c1 - c2)*cwp(i*n1,it)
         enddo
      enddo
      n1 = n1*2
   enddo
   do i = 0, n0-1, 2
      c1 = cf(i)
      c2 = cf(i+1)
      cf(i)   = c1 + c2
      cf(i+1) = c1 - c2
   enddo
   do i = 1, nr
      c1    = cf(irev1(i))
      cf(irev1(i)) = cf(irev2(i))
      cf(irev2(i)) = c1
   enddo
   if (mode == 2 .or. mode == -1) cf(:) = cf(:)/ns
end subroutine cfft
