!  10.5 qXgO
program make_histogram
   implicit none
   integer, parameter :: n0 = 1000, m0 = 10
   real nrand(n0),hist(0:m0-1),x1,x2,x,h,hmax
   integer ncmax,len,m
   character chist*100
   x1 = 0
   x2 = 100
   call normal_random(nrand,n0,18.0,55.0)
   call make_distribution(nrand,n0,x1,x2,hist,m0)
   hmax = maxval(hist)
   if (hmax == 0) hmax = 1
   h = (x2-x1)/m0
   ncmax = 50
   do m = 0, m0-1
      x = h*m + x1
      len = hist(m)*ncmax/hmax
      chist = repeat('*',len)
      print "(f6.1,' : ',a)",x,chist
   enddo
end program make_histogram

subroutine make_distribution(a,n,amin,amax,dist,md)
   implicit none
   real a(*),dist(0:md-1),amin,amax,h
   integer n,md,m,i
   dist(:) = 0
   h = (amax-amin)/md
   do i = 1, n
      m = (a(i)-amin)/h
      if (m < 0) then
         m = 0
       else if (m > md-1) then
         m = md-1
      endif
      dist(m) = dist(m) + 1
   enddo
end subroutine make_distribution

subroutine normal_random(nran,n,sig,x0)
   implicit none
   real, parameter :: pi  = 3.141592653589793, pi2 = 2*pi
   real nran(n),sig,x0,ang,dd
   integer n,i
   call random_number(nran(1:n))
   do i = 1, n, 2
      ang = pi2*nran(i+1)
      dd  = sig*sqrt(-2*log(nran(i)))
      nran(i)   = dd*cos(ang) + x0
      nran(i+1) = dd*sin(ang) + x0
   enddo
   if (mod(n,2) == 1) then
      call random_number(ang)
      ang = pi2*ang
      dd  = sig*sqrt(-2*log(nran(n)))
      nran(n) = dd*cos(ang) + x0
   endif
end subroutine normal_random
