!  10.8 ϕ_̌vZ
program equipartition_test
   implicit none
   integer, parameter :: n0 = 200, m0=30
   real xp(0:n0),yp(0:n0),dx,ww
   real xe(0:m0),xmin,xmax
   integer i
   xmin = -5
   xmax = 5
   dx = (xmax-xmin)/n0
   do i = 0, n0
      xp(i) = dx*i + xmin
      yp(i) = exp(-((xp(i)-3))**2) + 0.7*exp(-((xp(i)+2))**4/10)
   enddo
   call equipartition(xp,yp,n0,xe,m0,ww)
   do i = 0, m0
      print *,i,xe(i)
   enddo
end program equipartition_test

subroutine equipartition(xp,yp,n,xe,md,sa)
   implicit none
   real xp(0:n),yp(0:n),xe(0:md),ys(0:n),sa
   real a,b,c,dx,d,h,x,s
   integer n,md,i,k,i1 
   ys(0) = 0
   do i = 1, n
      ys(i) = ys(i-1) + (yp(i-1)+yp(i))*(xp(i)-xp(i-1))/2
      if (ys(i) < ys(i-1)) then
         print *,'Function data should be positive -- equipartition',i
         return
      endif
   enddo
   sa = ys(n)
   if (sa <= 0) then
      x = xp(0)
      print *,'Integrated value is zero -- equipartition'
      return
   endif
   xe(0)  = xp(0)
   xe(md) = xp(n)
   h  = sa/md
   i1 = 0
   do k = 1, md-1
      s = k*h
      do while (s > ys(i1+1))
         i1 = i1 + 1
      enddo
      dx = xp(i1+1)-xp(i1)
      a = yp(i1+1)-yp(i1)
      b = dx*yp(i1)
      c = 2*dx*(s-ys(i1))
      d = b*b + a*c
      xe(k) = xp(i1) + c/(b+sqrt(d))
   enddo
end subroutine equipartition
