!  10.9 WA1̌@@@\̉p\
program test_integer_gauss
   implicit none
   integer, parameter :: n0 = 4
   integer a(n0,n0),b(n0),x(10),q(10),sn(n0),mn(10),num(n0),det,dd
   integer k,kmax,i,qa,mod_integer
   kmax = 2
   q(1) = 977
   q(2) = 983
   call mult_integer_eucledean(q,kmax,sn,mn,qa)
   a(1,1) = 2;   a(1,2) =  4;   a(1,3) =  5;   a(1,4) =  2
   a(2,1) = 1;   a(2,2) = -8;   a(2,3) =  2;   a(2,4) = -6
   a(3,1) = 4;   a(3,2) =  1;   a(3,3) = -10;  a(3,4) = -2
   a(4,1) = 1;   a(4,2) =  7;   a(4,3) =  1;   a(4,4) = -2
   b(1)   = 9;   b(2)   = -3;   b(3)   =  1;   b(4)   = -3
   num(:) = 0
   det    = 0
   do k = 1, kmax
      call mod_gaussian(a,b,n0,x,dd,q(k))
      do i = 1, n0
         num(i) = num(i) + mod(sn(k)*x(i),q(k))*mn(k)
      enddo
      det = det + mod(sn(k)*dd,q(k))*mn(k)
   enddo
   do i = 1, n0
      num(i) = mod_integer(num(i),qa)
   enddo
   det = mod_integer(det,qa)
   if (det < 0) then
      det = -det
      num(1:n0) = -num(1:n0)
   endif
   do i = 1, n0
      print "(a,i3,a,i8,a,i5,a,f20.14)",'X(',i,') = ', &
                  num(i),' /',det,' =',real(num(i))/det
   enddo
end program test_integer_gauss

subroutine mod_gaussian(a,b,n,x,det,q)
   implicit none
   integer n,mod_div
   integer a(n,n),b(n),x(n),det,q
   integer i,j,k,dd
   integer, allocatable :: a1(:,:),b1(:)
   allocate ( a1(n,n), b1(n) )
   a1(:,:) = a(:,:);   b1(:) = b(:)
   do k = 1, n-1
      do i = k+1, n
         dd = mod_div(a1(i,k),a1(k,k),q)
         do j = k+1, n
            a1(i,j) = mod(a1(i,j)-dd*a1(k,j),q)
         enddo
         b1(i) = mod(b1(i)-dd*b1(k),q)
      enddo
   enddo
   x(n) = mod_div(b1(n),a1(n,n),q)
   do i = n-1, 1, -1
      dd = b1(i)
      do j = i+1, n
         dd = mod(dd-a1(i,j)*x(j),q)
      enddo
      x(i) = mod_div(dd,a1(i,i),q)
   enddo
   det = a1(1,1)
   do i = 2, n
      det = mod(det*a1(i,i),q)
   enddo
   do i = 1, n
      x(i) = mod(det*x(i),q)
   enddo
   deallocate ( a1, b1 )
end subroutine mod_gaussian

subroutine integer_eucledean(m0,n0,a,b,r)
   implicit none
   integer m0,n0,a,b,r
   integer n1,n2,nq,nr,a11,a12,a21,a22,d
   n1  = m0;   n2  = n0
   a11 = 1;    a12 = 0
   a21 = 0;    a22 = 1
   do 
      nq  = n1/n2
      nr  = n1 - nq*n2
      if (nr == 0) exit
      d   = a11 - a21*nq
      a11 = a21;      a21 = d
      d   = a12 - a22*nq
      a12 = a22;      a22 = d
      n1  = n2;      n2  = nr
   enddo
   if (n2 < 0) then
      a = -a21;   b = -a22;   r = -n2
    else
      a = a21;    b = a22;    r = n2
   endif
end subroutine integer_eucledean

subroutine mult_integer_eucledean(q,n,s,qd,qa)
   implicit none
   integer q(n),n,s(n),qd(n),qa,b,r,i
   integer ad
   qa = q(1)
   do i = 2, n
      qa = qa*q(i)
   enddo
   ad = 0
   do i = 1, n
      qd(i) = qa/q(i)
      call integer_eucledean(qd(i),q(i),s(i),b,r)
      ad = ad + s(i)*qd(i)
   enddo
end subroutine mult_integer_eucledean

function mod_div(m,n,q)
   implicit none
   integer mod_div,m,n,q,a,b,r
   call integer_eucledean(n,q,a,b,r)
   mod_div = mod(a*m,q)
   if (mod_div < 0) mod_div = mod_div + q
end function mod_div

function mod_integer(m,q)
   implicit none
   integer mod_integer,m,q
   mod_integer = mod(m,q)
   if (mod_integer >  q/2) then
      mod_integer = mod_integer - q
    else if (mod_integer < -q/2) then
      mod_integer = mod_integer + q
   endif
end function mod_integer
